'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 23 May 2014 at 11:00:24 am'!
Morph subclass: #BlockMorph
	instanceVariableNames: 'isSpecialForm oldColor highlightColor1 highlightColor2 shadowColor scratchProc hadError blockLayoutNeeded cachedForm cachedFeedbackForm copyTooltip lastLayoutTime isFlat '
	classVariableNames: 'ArgFont CBlockBracketThickness DebugMenu LabelColor LabelFont PuzzleInset PuzzleWidth AlternateDrawing '
	poolDictionaries: ''
	category: 'Scratch-Blocks'!
Morph subclass: #ScriptableScratchMorph
	instanceVariableNames: 'objName vars lists blocksBin isClone media costume costumeChangeMSecs filterPack visibility volume tempoBPM sceneStates dialogAns '
	classVariableNames: 'BlockColorDict BlockSpecDict DefaultBackgroundForm DefaultSpriteForm DoubleSize Experimental ListBlockColor MeowSound OldMeowPrefixReversed PopSound RandomGen Recorder ScratchOrigin TimerStartMSecs '
	poolDictionaries: ''
	category: 'Scratch-Objects'!

!BlockMorph methodsFor: 'initialization'!
initialize
	super initialize.
	blockLayoutNeeded _ true.
	isSpecialForm _ false.
	color _ Color
				r: 0.4
				g: 0.7
				b: 0.8.
	oldColor _ color.
	scratchProc _ nil.
	hadError _ false.
	lastLayoutTime _ 0! !

!BlockMorph methodsFor: 'drawing'!
computeHighlightColors
	| t1 t2 t3 |
	t1 _ color hue.
	t2 _ color saturation.
	t3 _ color brightness.
	AlternateDrawing
		ifTrue: 
			[highlightColor1 _ Color
						h: t1
						s: t2
						v: t3.
			highlightColor2 _ Color
						h: t1
						s: t2
						v: t3.
			shadowColor _ Color
						h: t1
						s: t2
						v: t3]
		ifFalse: 
			[highlightColor1 _ Color
						h: t1
						s: t2 - 0.13
						v: t3 + 0.1.
			highlightColor2 _ Color
						h: t1
						s: t2
						v: t3 + 0.07.
			shadowColor _ color mixed: 0.7 with: Color black]! !

!BlockMorph methodsFor: 'drawing'!
drawAlternateBodyOn: t1 
	t1 fillRectangle: (self left @ (self top + 4) corner: self right - 1 @ (self bottom - 7))
		color: color! !

!BlockMorph methodsFor: 'drawing'!
drawAlternateBottomEdgeOn: t1 
	| t2 t3 t4 t5 |
	t2 _ self width - 1.
	t3 _ self height - 7.
	t4 _ PuzzleInset.
	t5 _ PuzzleInset + PuzzleWidth.
	self
		drawHLineFrom: 1
		to: t2 - 1
		y: t3
		color: color
		on: t1.
	self
		drawHLineFrom: 2
		to: t2 - 2
		y: t3 + 1
		color: color
		on: t1.
	self
		drawHLineFrom: t4
		to: t5
		y: t3 + 2
		color: color
		on: t1.
	self
		drawHLineFrom: t4 + 1
		to: t5 - 1
		y: t3 + 3
		color: color
		on: t1.
	self
		drawHLineFrom: t4 + 1
		to: t5 - 1
		y: t3 + 4
		color: color
		on: t1.
	self
		drawHLineFrom: t4 + 2
		to: t5 - 2
		y: t3 + 5
		color: color
		on: t1! !

!BlockMorph methodsFor: 'drawing'!
drawAlternateReporterBodyOn: t1 
	t1 fillRectangle: (self left @ (self top + 3) corner: self right - 1 @ (self bottom - 3))
		color: color! !

!BlockMorph methodsFor: 'drawing'!
drawAlternateStopBodyOn: t1 
	t1 fillRectangle: (self left @ (self top + 5) corner: self right - 1 @ (self bottom - 3))
		color: color! !

!BlockMorph methodsFor: 'drawing'!
drawAlternateTopEdgeOn: t1 
	| t2 t3 t4 |
	t2 _ self width - 1.
	t3 _ PuzzleInset.
	t4 _ PuzzleInset + PuzzleWidth.
	self
		drawHLineFrom: 0
		to: t3 + 1
		y: 2
		color: color
		on: t1.
	self
		drawHLineFrom: t4 - 1
		to: t2
		y: 2
		color: color
		on: t1.
	self
		drawHLineFrom: 0
		to: t3 + 2
		y: 3
		color: color
		on: t1.
	self
		drawHLineFrom: t4 - 2
		to: t2
		y: 3
		color: color
		on: t1.
	self
		drawHLineFrom: 0
		to: t2
		y: 4
		color: color
		on: t1! !

!BlockMorph methodsFor: 'drawing'!
drawBodyOn: t1 
	t1 fillRectangle: (self left @ (self top + 4) corner: self right - 1 @ (self bottom - 7))
		color: color.
	t1 fillRectangle: (self left @ (self top + 2) corner: self left + 2 @ (self bottom - 7))
		color: highlightColor2.
	t1 fillRectangle: (self right - 1 @ (self top + 3) corner: self right @ (self bottom - 7))
		color: shadowColor! !

!BlockMorph methodsFor: 'drawing'!
drawBottomEdgeOn: t1 
	| t2 t3 t4 t5 |
	t2 _ self width - 1.
	t3 _ self height - 7.
	t4 _ PuzzleInset.
	t5 _ PuzzleInset + PuzzleWidth.
	self
		drawHLineFrom: 1
		to: t2 - 1
		y: t3
		color: color
		on: t1.
	self
		drawHLineFrom: 2
		to: t2 - 2
		y: t3 + 1
		color: color
		on: t1.
	self
		drawHLineFrom: t4
		to: t5
		y: t3 + 2
		color: color
		on: t1.
	self
		drawHLineFrom: t4 + 1
		to: t5 - 1
		y: t3 + 3
		color: color
		on: t1.
	self
		drawHLineFrom: t4 + 1
		to: t5 - 1
		y: t3 + 4
		color: color
		on: t1.
	self
		drawHLineFrom: t4 + 2
		to: t5 - 2
		y: t3 + 5
		color: color
		on: t1.
	self
		drawHLineFrom: 3
		to: t4
		y: t3 + 2
		color: shadowColor
		on: t1.
	self
		drawHLineFrom: t5
		to: t2 - 2
		y: t3 + 2
		color: shadowColor
		on: t1.
	self
		drawHLineFrom: t4 + 2
		to: t5 - 2
		y: t3 + 6
		color: shadowColor
		on: t1.
	self
		drawPoint: t4 @ (t3 + 3)
		color: shadowColor
		on: t1.
	self
		drawPoint: t4 @ (t3 + 4)
		color: shadowColor
		on: t1.
	self
		drawPoint: t4 + 1 @ (t3 + 5)
		color: shadowColor
		on: t1.
	self
		drawPoint: t5 - 1 @ (t3 + 3)
		color: shadowColor
		on: t1.
	self
		drawPoint: t5 - 1 @ (t3 + 4)
		color: shadowColor
		on: t1.
	self
		drawPoint: t5 - 2 @ (t3 + 5)
		color: shadowColor
		on: t1.
	self
		drawPoint: t2 - 1 @ t3
		color: shadowColor
		on: t1.
	self
		drawPoint: t2 - 2 @ (t3 + 1)
		color: shadowColor
		on: t1! !

!BlockMorph methodsFor: 'drawing'!
drawStopBodyOn: t1 
	t1 fillRectangle: (self left @ (self top + 5) corner: self right - 1 @ (self bottom - 3))
		color: color.
	t1 fillRectangle: (self left @ (self top + 2) corner: self left + 2 @ (self bottom - 3))
		color: highlightColor2.
	t1 fillRectangle: (self right - 1 @ (self top + 2) corner: self right @ (self bottom - 3))
		color: shadowColor! !

!BlockMorph methodsFor: 'drawing'!
drawTopEdgeOn: t1 
	| t2 t3 t4 |
	t2 _ self width - 1.
	t3 _ PuzzleInset.
	t4 _ PuzzleInset + PuzzleWidth.
	self
		drawHLineFrom: 2
		to: t3
		y: 0
		color: highlightColor1
		on: t1.
	self
		drawHLineFrom: t4
		to: t2 - 2
		y: 0
		color: highlightColor1
		on: t1.
	self
		drawHLineFrom: 1
		to: t3
		y: 1
		color: highlightColor2
		on: t1.
	self
		drawHLineFrom: t4
		to: t2 - 1
		y: 1
		color: highlightColor2
		on: t1.
	self
		drawHLineFrom: 0
		to: t3 + 1
		y: 2
		color: color
		on: t1.
	self
		drawHLineFrom: t4 - 1
		to: t2
		y: 2
		color: color
		on: t1.
	self
		drawHLineFrom: 0
		to: t3 + 2
		y: 3
		color: color
		on: t1.
	self
		drawHLineFrom: t4 - 2
		to: t2
		y: 3
		color: color
		on: t1.
	self
		drawHLineFrom: 0
		to: t2
		y: 4
		color: color
		on: t1.
	self
		drawHLineFrom: t3 + 2
		to: t4 - 2
		y: 4
		color: highlightColor1
		on: t1! !

!BlockMorph methodsFor: 'drawing'!
makeFlat
	isFlat _ true! !

!BlockMorph methodsFor: 'drawing'!
makeNormal
	isFlat _ false! !

!BlockMorph methodsFor: 'event handling'!
rightButtonMenu
	| t1 |
	t1 _ CustomMenu new.
	t1 add: 'help' action: #presentHelpScreen.
	(owner isKindOf: ScratchBlockPaletteMorph)
		ifFalse: 
			[t1 addLine.
			t1 add: 'duplicate' action: #duplicate.
			(self owner isKindOf: BlockMorph)
				ifFalse: [t1 add: 'delete' action: #delete]].
	DebugMenu
		ifTrue: 
			[t1 addLine.
			t1 add: 'show tuples' action: #showTuples].
	t1 localize; invokeOn: self! !


!BooleanArgMorph methodsFor: 'drawing'!
isRectangular
	^ false! !


!CommandBlockMorph methodsFor: 'accessing'!
toggleAlternateDrawing
	AlternateDrawing = true
		ifTrue: [AlternateDrawing _ false]
		ifFalse: [AlternateDrawing _ true]! !

!CommandBlockMorph methodsFor: 'menus'!
rightButtonMenu
	| t1 t2 t3 t4 |
	t1 _ CustomMenu new.
	t1 add: 'help' action: #presentHelpScreen.
	(owner isKindOf: ScratchBlockPaletteMorph)
		ifFalse: 
			[t1 addLine.
			(#(#+ #- #* #/ #\\ ) includes: selector)
				ifTrue: [#(#+ #- #* #/ #mod ) with: #(#+ #- #* #/ #\\ ) do: [:t5 :t6 | t1 add: t5 action: t6]].
			(#(#< #= #> ) includes: selector)
				ifTrue: [#(#< #= #> ) do: [:t6 | t1 add: t6 action: t6]].
			(#(#& #| ) includes: selector)
				ifTrue: [#(#and #or ) with: #(#& #| ) do: [:t5 :t6 | t1 add: t5 action: t6]].
			t1 addLine.
			t1 add: 'duplicate' action: #duplicate.
			(self owner isKindOf: BlockMorph)
				ifFalse: [t1 add: 'delete' action: #delete]].
	t2 _ self ownerThatIsA: ScratchFrameMorph.
	(t2 notNil and: [#(#sensor: #sensorPressed: ) includes: selector])
		ifTrue: 
			[t1 addLine.
			t1 add: 'show ScratchBoard watcher' action: #showSensorBoard.
			t2 workPane scratchServer ifNil: [t1 add: 'enable remote sensor connections' action: #enableRemoteSensors]
				ifNotNil: [t1 add: 'disable remote sensor connections' action: #exitScratchSession]].
	t1 addLine.
	t1 add: 'show tuples' action: #showTuples.
	t1 add: 'show spec' action: #showSpec.
	(t3 _ t1 localize; startUp) ifNil: [^ self].
	(#(#presentHelpScreen #duplicate #delete ) includes: t3)
		ifTrue: [^ self perform: t3].
	t3 = #showSensorBoard
		ifTrue: 
			[t2 showSensorBoard.
			^ self].
	t3 = #enableRemoteSensors
		ifTrue: 
			[t2 enableRemoteSensors.
			^ self].
	t3 = #exitScratchSession
		ifTrue: 
			[t2 exitScratchSession.
			^ self].
	t3 = #showTuples ifTrue: [^ self showTuples].
	t3 = #showSpec ifTrue: [^ self showSpec].
	t4 _ '%n ' , t3 , ' %n'.
	'\\' = t3 ifTrue: [t4 _ ScratchTranslator translationFor: '%n mod %n'].
	'&' = t3 ifTrue: [t4 _ ScratchTranslator translationFor: '%b and %b'].
	'|' = t3 ifTrue: [t4 _ ScratchTranslator translationFor: '%b or %b'].
	self commandSpec: t4.
	self selector: t3! !

!CommandBlockMorph methodsFor: 'private'!
uncoloredArgMorphFor: t1 
	| t2 |
	t2 _ t1 at: 2.
	$a = t2 ifTrue: [^ AttributeArgMorph new choice: 'volume'].
	$b = t2 ifTrue: [^ BooleanArgMorph new].
	$c = t2 ifTrue: [^ ColorArgMorph new showPalette: true].
	$C = t2 ifTrue: [^ ColorArgMorph new showPalette: false].
	$d = t2 ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '0';
		 menuSelector: #directionMenu].
	$D = t2 ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '48';
		 menuSelector: #midiDrumMenu].
	$e = t2 ifTrue: [^ EventTitleMorph new].
	$f = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #mathFunctionNames;
		 choice: 'sqrt'].
	$g = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #graphicEffectNames;
		 choice: 'color'].
	$H = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #hookupSensorNames].
	$h = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #hookupBooleanSensorNames].
	$I = t2 ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '1';
		 menuSelector: #midiInstrumentMenu].
	$i = t2 ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '1';
		 menuSelector: #listIndexMenu].
	$k = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #keyNames;
		 choice: 'space'].
	$L = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #listVarMenu].
	$l = t2 ifTrue: [^ ChoiceOrExpressionArgMorph new getOptionsSelector: #costumeNames;
		 choice: 'costume1'].
	$m = t2 ifTrue: [^ SpriteArgMorph new].
	$M = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #motorNames].
	$n = t2 ifTrue: [^ ExpressionArgMorph new numExpression: '10'].
	$N = t2 ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '60';
		 menuSelector: #noteSelector].
	$s = t2 ifTrue: [^ ExpressionArgMorph new stringExpression: ''].
	$S = t2 ifTrue: [^ ChoiceOrExpressionArgMorph new getOptionsSelector: #soundNames;
		 choice: 'pop'].
	$v = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #varNamesMenu;
		 choice: ''].
	$V = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #variableEditMenu;
		 choice: 'increment'].
	$W = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #motorDirection].
	$x = t2 ifTrue: [^ ChoiceOrExpressionArgMorph new getOptionsSelector: #sceneNames;
		 choice: ''].
	$y = t2 ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '1';
		 menuSelector: #listIndexForDeleteMenu].
	$t = t2 ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #dialogTypeDropdown;
		 choice: 'ask'].
	^ ExpressionArgMorph new numExpression: '10'! !

!CommandBlockMorph methodsFor: 'spec change'!
showSpec
	DialogBoxMorph inform: commandSpec! !


!CBlockMorph methodsFor: 'drawing'!
drawVerticalBarOn: t1 
	| t2 t3 t4 |
	t2 _ self left.
	t4 _ t2 + CBlockBracketThickness - 1.
	t3 _ self top.
	t1 fillRectangle: (t2 @ (t3 + 5) corner: t4 @ blockBottom)
		color: color.
	t1 fillRectangle: (t2 @ (t3 + 2) corner: t2 + 2 @ blockBottom)
		color: highlightColor2.
	t1 fillRectangle: (t4 @ (topBarBottom + 4) corner: t4 + 1 @ blockBottom)
		color: shadowColor! !


!ExpressionArgMorph methodsFor: 'drawing'!
drawOn: t1 
	| t2 t3 t4 t5 t6 t7 t8 |
	isNumber ifFalse: [^ super drawOn: t1].
	t3 _ self width.
	t4 _ t5 _ t6 _ self height // 2.
	self height even ifTrue: [t4 _ t5 - 1].
	[t4 >= 0]
		whileTrue: 
			[t7 _ t6 - (t6 squared - (t6 - t4 - 1) squared) sqrt rounded.
			self
				drawHLineFrom: t7
				to: t7 + 1
				y: t4
				color: t2
				on: t1.
			t8 _ t4 < 1
						ifTrue: [t2]
						ifFalse: [Color white].
			self
				drawHLineFrom: t7 + 1
				to: t3 - (t7 + 1)
				y: t4
				color: t8
				on: t1.
			self
				drawHLineFrom: t3 - (t7 + 1)
				to: t3 - t7
				y: t4
				color: t2
				on: t1.
			self
				drawHLineFrom: t7
				to: t3 - t7
				y: t5
				color: Color white
				on: t1.
			t7 = 0
				ifTrue: 
					[self
						drawHLineFrom: t7 + 1
						to: t7 + 2
						y: t4
						color: Color white
						on: t1.
					self
						drawHLineFrom: t7
						to: t7 + 1
						y: t5
						color: t2
						on: t1.
					self
						drawHLineFrom: t3 - (t7 + 1)
						to: t3 - t7
						y: t5
						color: t2
						on: t1].
			t5 _ t5 + 1.
			t4 _ t4 - 1]! !

!ExpressionArgMorph methodsFor: 'private'!
fixArgLayout
	| t1 t2 t3 |
	t1 _ self top.
	isNumber
		ifTrue: 
			[self extent: labelMorph extent + (5 @ 0).
			Smalltalk isWindows ifFalse: [t1 _ t1 + 0].
			t3 _ self height - (1.3 * self width) rounded max: 0.
			t3 > 0 ifTrue: [self width: self width + t3].
			t2 _ 3.5 + (t3 // 2)]
		ifFalse: 
			[self extent: labelMorph extent + (2 @ 0).
			t2 _ 3].
	ScratchTranslator isRTL
		ifTrue: [labelMorph position: self right - (t2 + labelMorph width) @ t1]
		ifFalse: [labelMorph position: self left + t2 @ t1]! !


!NewVariableDialog methodsFor: 'initialization'!
initialize
	| t1 t2 |
	super initialize.
	spriteSpecificFlag _ false.
	radioButtons _ AlignmentMorph newRow color: Color transparent;
			 hResizing: #shrinkWrap;
			 vResizing: #shrinkWrap.
	allSpritesRadioButton _ ToggleButton onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
				offForm: (ScratchFrameMorph skinAt: #radioButton).
	allSpritesRadioButton on; target: self; actionSelector: #toggleSpriteSpecific.
	t1 _ StringMorph new contents: 'For all sprites' localized;
			 font: (ScratchFrameMorph getFont: #NewVariableDialogBox).
	radioButtons addMorphBack: allSpritesRadioButton.
	radioButtons addMorphBack: (Morph new extent: 5 @ 5;
		 color: Color transparent).
	radioButtons addMorphBack: t1.
	radioButtons addMorphBack: (Morph new extent: 15 @ 5;
		 color: Color transparent).
	thisSpriteRadioButton _ allSpritesRadioButton fullCopy off.
	t2 _ StringMorph new contents: 'For this sprite only' localized;
			 font: (ScratchFrameMorph getFont: #NewVariableDialogBox).
	radioButtons addMorphBack: thisSpriteRadioButton.
	radioButtons addMorphBack: (Morph new extent: 5 @ 5;
		 color: Color transparent).
	radioButtons addMorphBack: t2.
	ScratchTranslator isRTL ifTrue: [radioButtons submorphs reversed do: 
			[:t3 | 
			t3 delete.
			radioButtons addMorphBack: t3]].
	mainColumn
		submorphsDo: [:t3 | (t3 = messageLineMorphs) not ifTrue: [t3 delete]].
	mainColumn addMorphBack: (Morph new extent: 5 @ 5;
		 color: Color transparent);
	 addMorphBack: typeinMorph;
	 addMorphBack: (Morph new extent: 5 @ 7;
		 color: Color transparent);
	 addMorphBack: radioButtons;
	 addMorphBack: (Morph new extent: 5 @ 7;
		 color: Color transparent);
	 addMorphBack: buttonRow;
	 addMorphBack: bottomSpacer! !


!ReporterBlockMorph methodsFor: 'drawing'!
drawBooleanOn: t1 
	| t2 t3 t4 t5 t6 |
	self computeHighlightColors.
	t2 _ self width.
	t3 _ t4 _ self height // 2.
	self height even ifTrue: [t3 _ t4 - 1].
	t5 _ 0.
	[t3 >= 0]
		whileTrue: 
			[t3 = 0 ifTrue: [t6 _ highlightColor1].
			t3 = 1 ifTrue: [t6 _ highlightColor2].
			t3 > 1 ifTrue: [t6 _ color].
			self
				drawHLineFrom: t5
				to: t2 - t5
				y: t3
				color: t6
				on: t1.
			t3 > 1 & (t5 > 0)
				ifTrue: 
					[self
						drawPoint: t5 @ t3
						color: highlightColor1
						on: t1.
					self
						drawPoint: t2 - t5 - 1 @ t3
						color: shadowColor
						on: t1].
			t6 _ t4 = (self height - 1)
						ifTrue: [shadowColor]
						ifFalse: [color].
			self
				drawHLineFrom: t5
				to: t2 - t5
				y: t4
				color: t6
				on: t1.
			t5 > 0
				ifTrue: 
					[self
						drawPoint: t5 @ t4
						color: shadowColor
						on: t1.
					self
						drawPoint: t2 - t5 - 1 @ t4
						color: shadowColor
						on: t1].
			t5 _ t5 + 1.
			t4 _ t4 + 1.
			t3 _ t3 - 1]! !

!ReporterBlockMorph methodsFor: 'drawing'!
drawNumericOn: t1 
	| t2 t3 t4 t5 t6 t7 |
	self computeHighlightColors.
	t2 _ self width.
	t3 _ t4 _ t5 _ self height // 2.
	self height even ifTrue: [t3 _ t4 - 1].
	[t3 >= 0]
		whileTrue: 
			[t6 _ t5 - (t5 squared - (t5 - t3 - 1) squared) sqrt rounded.
			t3 = 0 ifTrue: [t7 _ highlightColor1].
			t3 = 1 ifTrue: [t7 _ highlightColor2].
			t3 > 1 ifTrue: [t7 _ color].
			self
				drawHLineFrom: t6
				to: t2 - t6
				y: t3
				color: t7
				on: t1.
			t6 > 0 & (t3 > 1)
				ifTrue: 
					[self
						drawPoint: t6 @ t3
						color: highlightColor1
						on: t1.
					self
						drawPoint: t2 - t6 - 1 @ t3
						color: highlightColor1
						on: t1].
			t7 _ t4 = (self height - 1)
						ifTrue: [shadowColor]
						ifFalse: [color].
			self
				drawHLineFrom: t6
				to: t2 - t6
				y: t4
				color: t7
				on: t1.
			t6 > 0
				ifTrue: 
					[self
						drawPoint: t6 @ t4
						color: shadowColor
						on: t1.
					self
						drawPoint: t2 - t6 - 1 @ t4
						color: shadowColor
						on: t1].
			t4 _ t4 + 1.
			t3 _ t3 - 1]! !

!ReporterBlockMorph methodsFor: 'other'!
computeHighlightColors
	| t1 t2 t3 |
	t1 _ color hue.
	t2 _ color saturation.
	t3 _ color brightness.
	AlternateDrawing
		ifTrue: 
			[highlightColor1 _ Color
						h: t1
						s: t2
						v: t3.
			highlightColor2 _ Color
						h: t1
						s: t2
						v: t3.
			shadowColor _ Color
						h: t1
						s: t2
						v: t3]
		ifFalse: 
			[highlightColor1 _ Color
						h: t1
						s: t2 - 0.13
						v: t3 + 0.17.
			highlightColor2 _ Color
						h: t1
						s: t2
						v: t3 + 0.06.
			shadowColor _ color mixed: 0.8 with: Color black]! !


!ResizableToggleButton2 methodsFor: 'event'!
readScratchSkin
	ScratchFrameMorph readSkinFrom: (FileDirectory default directoryNamed: 'ScratchSkin')! !


!ScratchBlockPaletteMorph methodsFor: 'dropping/grabbing'!
isPartsBin
	^ true! !


!ScratchCommentMorph methodsFor: 'accessing'!
commentMorphColor
	^ Color
		r: 100
		g: 100
		b: 255! !

!ScratchCommentMorph methodsFor: 'private'!
defaultWidth
	^ 100! !

!ScratchCommentMorph methodsFor: 'private'!
topBarColor
	^ Color
		r: 255
		g: 1
		b: 1! !

!ScratchCommentMorph methodsFor: 'private'!
updateAnchorOffset
	| t1 t2 t3 t4 t5 t6 t7 t8 |
	anchor ifNil: [^ self].
	self resetAnchorOffset.
	isShowing ifFalse: [^ self].
	t1 _ 10.
	t2 _ anchor topBlock allMorphs reversed
				select: [:t9 | (t9 isKindOf: BlockMorph)
						and: [t9 isReporter not]].
	t6 _ self commentsBeforeMe: t2.
	t7 _ self commentsAfterMe: t2.
	t8 _ t7 select: [:t10 | t10 isShowing not].
	t6 , t8 do: [:t10 | t10 resetAnchorOffset].
	t6 do: [:t10 | t10 updateAnchorOffset].
	t4 _ t2 , t6 , t8.
	t3 _ t4
				collect: [:t9 | (t9 isKindOf: BlockMorph)
						ifTrue: [t9 bounds origin extent: t9 bounds extent - (0 @ 4)]
						ifFalse: [t9 bounds]].
	
	[t5 _ t3 detect: [:t11 | t11 intersects: self bounds]
				ifNone: [].
	t5 isNil]
		whileFalse: [ScratchTranslator isRTL
				ifTrue: [self right: (self right min: t5 left - t1)]
				ifFalse: [self left: (self left max: t5 right + t1)]].
	ScratchTranslator isRTL
		ifTrue: [anchorOffset _ anchor left - self right]
		ifFalse: [anchorOffset _ self left - anchor right].
	self updatePosition! !


!ScratchConnectorMorph methodsFor: 'as yet unclassified'!
drawOn: t1 
	point1 isNil | point2 isNil ifTrue: [^ self].
	t1
		line: point1
		to: point2
		width: 4
		color: color! !

!ScratchConnectorMorph methodsFor: 'as yet unclassified'!
from: t1 to: t2 
	| t3 t4 t5 t6 |
	point1 = t1 & (point2 = t2) ifTrue: [^ self].
	point1 _ t1.
	point2 _ t2.
	t3 _ point1 x min: point2 x.
	t4 _ point1 x max: point2 x.
	t5 _ point1 y min: point2 y.
	t6 _ point1 y max: point2 y.
	self position: t3 @ t5.
	self extent: t4 - t3 @ (t6 - t5 max: 1)! !


!ScratchFrameMorph methodsFor: 'intialization'!
createBasicPanes
	topPane _ ImageFrameMorph new initFromForm: (ScratchFrameMorph skinAt: 'topPane').
	viewerPane _ ScratchViewerMorph new rebuildCategorySelectors.
	scriptsPane _ ScratchScriptEditorMorph new.
	stageFrame _ ImageFrameMorph new initFromForm: (ScratchFrameMorph skinAt: 'stagePane').
	titlePane _ ImageFrameMorph new initFromForm: (ScratchFrameMorph skinAt: 'titlePane').
	workPane _ ScratchStageMorph new extent: WorkpaneExtent.
	libraryPane _ ScratchLibraryMorph new.
	self addMorph: (topPane isSticky: true);
	 addMorph: (viewerPane isSticky: true);
	 addMorph: (scriptsPane isSticky: true);
	 addMorph: (stageFrame isSticky: true);
	 addMorph: (workPane isSticky: true);
	 addMorph: (titlePane isSticky: true);
	 addMorph: (libraryPane isSticky: true).
	self createReadoutPane.
	workPane comeToFront! !

!ScratchFrameMorph methodsFor: 'intialization'!
createMenuPanel
	| t1 t2 |
	menuPanel _ AlignmentMorph new color: Color transparent;
			 centering: #center;
			 inset: 0;
			 height: 0.
	self addShortcutButtonsTo: menuPanel.
	t1 _ #((#File #fileMenu:) (#Edit #editMenu:) (#Help #helpMenu:) ).
	t1 do: 
		[:t3 | 
		t2 _ ScratchMenuTitleMorph new contents: (t3 at: 1) localized;
				 target: self selector: (t3 at: 2).
		menuPanel addMorphBack: t2.
		#helpMenu: = (t3 at: 2) ifFalse: [menuPanel addMorphBack: (Morph new color: Color transparent;
				 extent: 12 @ 5)]].
	topPane addMorph: menuPanel! !

!ScratchFrameMorph methodsFor: 'intialization'!
initialize
	super initialize.
	fillScreenFlag _ false.
	paintingInProgress _ false.
	projectInfo _ Dictionary new.
	watcherPositions _ Dictionary new.
	justSaved _ false.
	author _ ''.
	loginName _ ''.
	loginPassword _ ''.
	viewMode _ #quarter.
	self createBasicPanes.
	self createLogo.
	self createMenuPanel.
	self createViewModeButtonsPanel.
	self createStageButtonsPanel.
	self createToolbar.
	self extent: 500 @ 600! !

!ScratchFrameMorph methodsFor: 'menu/button actions'!
about4mod
	| t1 |
	t1 _ DialogBoxMorph new title: 'About 4Mod';
			
				withButtonsForYes: false
				no: false
				okay: true
				cancel: false.
	t1 message: '4Mod, based on Scratch
Copyright 2014 by Scratch user liam48D.
All rights reserved.. I think? Not sure what that means. =P

Developed by MEH,
with support from the MEH DAD, MEH MOM, The Lifelong Kindergarden Group of MIT,
SOMEBODY ELSE, and SUPPORTERS ON MY SCRATCH PAGE FOR 4Mod.
Also, thanks to YOU for downloading this!! =D

' font: (ScratchFrameMorph getFont: #AboutScratch).
	t1 getUserResponse! !

!ScratchFrameMorph methodsFor: 'menu/button actions'!
fileMenu: t1 
	| t2 |
	t2 _ CustomMenu new.
	t2 add: 'New' action: #newScratchProject.
	t2 add: 'Open' action: #openScratchProject.
	t2 add: 'Save (Hacks not supported)' action: #saveScratchProjectNoDialog.
	t2 add: 'Save As (Hacks not supported)' action: #saveScratchProject.
	t2 addLine.
	t2 add: 'Import Project' action: #importScratchProject.
	t2 add: 'Export Sprite' action: #exportSprite.
	t2 addLine.
	t2 add: 'Project Notes' action: #editNotes.
	Sensor shiftPressed
		ifTrue: 
			[t2 addLine.
			t2 add: 'Write Project Summary' action: #writeSummaryFile.
			t2 add: 'Write Multiple Project Summaries' action: #writeMultipleSummaries.
			t2 addLine].
	t2 addLine.
	t2 add: 'Quit' action: #quitScratch.
	t2 localize.
	#(2 4 5 6 7 ) do: [:t3 | t2 labels at: t3 put: ((t2 labels at: t3)
				copyFrom: 1 to: (t2 labels at: t3) size - 1)
				, ScratchTranslator ellipsesSuffix].
	t2 invokeOn: self at: t1 bottomLeft + (0 @ 10)! !

!ScratchFrameMorph methodsFor: 'menu/button actions'!
helpMenu: t1 
	| t2 |
	t2 _ CustomMenu new.
	t2 add: 'Help Page' action: #launchHelpPage.
	t2 add: 'Help Screens' action: #launchAllHelpScreens.
	t2 addLine.
	t2 add: 'About Scratch' action: #aboutScratch.
	t2 add: 'About 4Mod' action: #about4mod.
	t2 localize.
	#(1 2 3 ) do: [:t3 | t2 labels at: t3 put: ((t2 labels at: t3)
				copyFrom: 1 to: (t2 labels at: t3) size - 1)
				, ScratchTranslator ellipsesSuffix].
	t2 invokeOn: self at: t1 bottomLeft + (0 @ 10)! !

!ScratchFrameMorph methodsFor: 'startup'!
startup
	| t1 t2 t3 t4 |
	HostSystemMenus startUp.
	HostSystemMenus menuBarControler reviseHostMenus.
	ScriptableScratchMorph randomInit.
	ScratchTranslator detectRenderPlugin.
	ScratchTranslator importLanguagesList.
	self processSettingsFile.
	self readDefaultNotes.
	self updateProjectName.
	shuffledCostumeNames _ nil.
	author _ 'Me'.
	loginName _ ''.
	loginPassword _ ''.
	justSaved _ true.
	t4 _ false.
	t1 _ InputSensor startupFileNames asOrderedCollection.
	2 to: 10 do: 
		[:t5 | 
		t3 _ Smalltalk getSystemAttribute: t5.
		(t3 notNil and: [t3 size > 0])
			ifTrue: [t1 addLast: (ScratchPlugin primShortToLongPath: t3)]].
	t1 do: 
		[:t6 | 
		t6 asLowercase = 'presentation' ifTrue: [t4 _ true].
		t6 asLowercase = 'fullscreen' ifTrue: [TakeOverScreen _ true]].
	TakeOverScreen
		ifTrue: 
			[Smalltalk fullScreenMode: true.
			World restoreDisplay].
	self enterQuarterModeIfSmallScreen.
	t2 _ t1
				detect: [:t7 | (t7 asLowercase endsWith: '.sb')
						or: [t7 asLowercase endsWith: '.scratch']]
				ifNone: [].
	t2
		ifNotNil: 
			[t4 ifTrue: [Display fillColor: Color black].
			self openScratchProjectNamed: t2.
			t4 ifTrue: [self enterPresentationMode; shoutGo].
			^ self].
	viewerPane currentCategory: 'motion'.
	self setDefaultSprite.
	self newScratchProject.
	t2 _ t1 detect: [:t7 | t7 asLowercase endsWith: '.sprite']
				ifNone: [^ self].
	workPane submorphs do: [:t8 | (t8 isKindOf: ScratchSpriteMorph)
			ifTrue: [t8 deleteSprite]].
	self importSpriteOrProject: t2! !


!ScratchLibraryMorph methodsFor: 'initialization'!
makeNewSpriteButtons: t1 
	| t2 t3 t4 t5 t6 t7 |
	t2 _ Morph new color: Color transparent.
	t3 _ #((#newSpritePaint #paintSpriteMorph 'Paint new sprite') (#newSpriteLibrary #addSpriteMorph 'Choose new sprite from file') ).
	t4 _ t3
				collect: 
					[:t8 | 
					t5 _ ToggleButton new onForm: (ScratchFrameMorph skinAt: (t8 at: 1))
								offForm: (ScratchFrameMorph skinAt: (t8 at: 1)).
					t5 target: t1;
					 actionSelector: (t8 at: 2);
					 setProperty: #balloonText toValue: (t8 at: 3) localized.
					t5].
	t6 _ ScratchFrameMorph isXO
				ifTrue: [37 @ 27]
				ifFalse: [37 @ 27].
	t7 _ 0.
	t4 do: 
		[:t9 | 
		t9 extent: t6.
		t2 addMorph: (t9 position: t7 @ 1).
		t7 _ t7 + 5 + t9 width].
	t2 extent: t7 @ (t6 y + 1).
	^ t2! !


!ScratchListMorph methodsFor: 'initialization'!
addScrollPane
	scrollPane _ ScrollFrameMorph2 new vBarInset: 16;
			 hBarInset: 18;
			 color: Color transparent;
			 growthFraction: 0.0;
			 scrollbarStartInset: 2 endInset: -2;
			 contents: (Morph new color: Color transparent).
	self addMorph: scrollPane! !

!ScratchListMorph methodsFor: 'initialization'!
addTitleAndControls
	titleMorph _ StringMorph new contents: 'myList';
			 font: (ScratchFrameMorph getFont: #Label).
	addItemMorph _ ImageMorph new form: (ScratchFrameMorph skinAt: #addItem).
	resizeMorph _ ScratchResizeMorph ofType: #corner.
	countMorph _ StringMorph new contents: '0';
			 font: (ScratchFrameMorph getFont: #XYReadout);
			 color: (Color gray: 0.15).
	emptyMorph _ StringMorph new contents: '(empty)' localized;
			 font: (ScratchFrameMorph getFont: #CommentBlock).
	self addMorph: titleMorph.
	self addMorph: addItemMorph.
	self addMorph: resizeMorph.
	self addMorph: countMorph! !

!ScratchListMorph methodsFor: 'geometry'!
fixLayout
	titleMorph fitContents.
	titleMorph width > (self width - 12) ifTrue: [self width: titleMorph width + 12].
	titleMorph position: self center x - (titleMorph width // 2) @ (self top + 5).
	countMorph fitContents.
	scrollPane position: self left + 10 @ (titleMorph bottom + 3);
	 extent: self width - 4 @ (self bottom - titleMorph bottom - countMorph height - 12).
	addItemMorph position: self left + 3 @ (self bottom - addItemMorph height - 3).
	resizeMorph position: self bottomRight - resizeMorph extent.
	self updateCountMorph.
	countMorph bottom: self bottom - 3.
	self updateContents! !


!ScratchPrompterMorph methodsFor: 'accessing'!
question: t1 
	questionMorph _ StringMorph new contents: t1;
			 font: (ScratchFrameMorph getFont: #DialogBoxButton).
	self addMorph: questionMorph.
	self height: questionMorph height + typeinMorph height + 16! !


!ScratchScriptEditorMorph methodsFor: 'initialization'!
createTabPane
	| t1 t2 t3 t4 |
	tabPaneMorph _ ScratchTabPaneMorph new.
	tabPaneMorph borderWidth: 0;
	 color: Color transparent;
	 targetPane: self.
	t1 _ ScratchFrameMorph skinAt: #tabOn.
	t2 _ ScratchFrameMorph skinAt: #tabOff.
	#(#Scripts #Costumes #Sounds ) do: 
		[:t5 | 
		t3 _ t5 asString.
		t4 _ t3 localized.
		tabPaneMorph
			createTab: t3
			withLabel: t4
			onForm: t1
			offForm: t2].
	tabPaneMorph currentTab: 'Scripts'.
	self addMorph: tabPaneMorph! !

!ScratchScriptEditorMorph methodsFor: 'menu/button ops'!
scriptsMenu: t1 
	| t2 t3 |
	self target ifNil: [^ self].
	t2 _ CustomMenu new.
	t2 add: 'clean up' action: #cleanUp.
	t2 add: 'save picture of scripts' action: #saveScriptsToImage.
	t2 add: 'add comment' action: #addComment:.
	t3 _ t2 localize startUp.
	t3 ifNil: [^ self].
	t3 = #addComment:
		ifTrue: [self perform: t3 with: t1]
		ifFalse: [self perform: t3]! !


!ScratchTalkBubbleMorph methodsFor: 'drawing'!
hasTranslucentColor
	^ false! !


!ScratchViewerMorph methodsFor: 'initialization'!
rebuildCategorySelectors
	| t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 |
	t1 _ #(#motion #control #looks #sensing #sound #operators #pen #variables #other #squeak #dialogs #mesh ).
	submorphs do: [:t14 | (t14 isKindOf: ResizableToggleButton2)
			ifTrue: [t14 delete]].
	t2 _ 75 @ 0.
	t3 _ t1
				collect: 
					[:t15 | 
					t4 _ (ScratchTranslator translationFor: t15 asString) capitalized.
					t5 _ ScratchFrameMorph skinAt: t15.
					t6 _ ScratchFrameMorph skinAt: t15 , 'Pressed'.
					t7 _ ScratchFrameMorph skinAt: t15 , 'Over'.
					ScratchTranslator isRTL
						ifTrue: [t8 _ ResizableToggleButton2 new
										offForm: (t5 flipBy: #horizontal centerAt: t5 center)
										onForm: (t6 flipBy: #horizontal centerAt: t6 center)
										overForm: (t7 flipBy: #horizontal centerAt: t7 center)]
						ifFalse: [t8 _ ResizableToggleButton2 new
										offForm: t5
										onForm: t6
										overForm: t7].
					t8 label: t4 font: (ScratchFrameMorph getFont: #Category);
					 setLabelColor: Color white;
					 target: self;
					 actionSelector: #currentCategory:;
					 arguments: (Array with: t15);
					 toggleButtonMode: true;
					 toggleMode: false.
					ScratchTranslator isRTL
						ifTrue: [t8 rightJustifyInset: 10]
						ifFalse: [t8 leftJustifyInset: 10].
					t2 _ t2 max: t8 extent + (3 @ -6).
					t8].
	t9 _ 15.
	catButtonsExtent _ 2 * t2 x + (3 * t9) @ (t1 size // 2 * (t2 y + 6) + 25).
	t10 _ self left + 12 + t9.
	t11 _ t10 + t2 x + t9.
	t12 _ t10.
	t13 _ self top + 17.
	1 to: t3 size do: 
		[:t16 | 
		t8 _ t3 at: t16.
		t8 extent: t2.
		self addMorph: (t8 position: t12 @ t13).
		t16 even
			ifTrue: 
				[t12 _ t10.
				t13 _ t13 + t8 height + 6]
			ifFalse: [t12 _ t11]].
	self width: catButtonsExtent x.
	pageViewer position: self position + (0 @ catButtonsExtent y).
	topSectionHeight _ catButtonsExtent y - 4! !

!ScratchViewerMorph methodsFor: 'drawing'!
drawBackgroundOn: t1 
	color isTransparent ifTrue: [^ self].
	t1 fillRectangle: (self topLeft extent: self width @ catButtonsExtent y)
		color: (Color
				r: 220
				g: 200
				b: 200)! !


!ScriptableScratchMorph methodsFor: 'dialog ops'!
ask: t1 withCancel: t2 initialAnswer: t3 
	t2
		ifTrue: [t3
				ifTrue: [StringDialog askWithCancel: t1 initialAnswer: t3]
				ifFalse: [StringDialog askWithCancel: t1]]
		ifFalse: [t3
				ifTrue: [StringDialog ask: t1 initialAnswer: t3]
				ifFalse: [StringDialog ask: t1]]! !

!ScriptableScratchMorph methodsFor: 'dialog ops'!
ask: t1 withCancel: t2 isInitial: t3 initialAnswer: t4 
	t2 = true
		ifTrue: [t3 = true
				ifTrue: [StringDialog askWithCancel: t1 initialAnswer: t4]
				ifFalse: [StringDialog askWithCancel: t1]]
		ifFalse: [t3 = true
				ifTrue: [StringDialog ask: t1 initialAnswer: t4]
				ifFalse: [StringDialog ask: t1]]! !

!ScriptableScratchMorph methodsFor: 'dialog ops'!
askInDialog: t1 
	DialogBoxMorph ask: t1! !

!ScriptableScratchMorph methodsFor: 'dialog ops'!
askInDialogWithCancel: t1 
	DialogBoxMorph askWithCancel: t1! !

!ScriptableScratchMorph methodsFor: 'dialog ops'!
dialogTypeDropdown
	^ #('ask if' 'warn' 'inform' )! !

!ScriptableScratchMorph methodsFor: 'dialog ops'!
do: t1 what: t2 withCancel: t3 
	t1 = 'ask if'
		ifTrue: [t3 = true
				ifTrue: [DialogBoxMorph askWithCancel: t2]
				ifFalse: [DialogBoxMorph ask: t2]].
	t1 = 'warn' ifTrue: [DialogBoxMorph warn: t2].
	t1 = 'inform'
		ifTrue: [t3 = true
				ifTrue: [DialogBoxMorph informWithCancel: t2]
				ifFalse: [DialogBoxMorph inform: t2]]! !

!ScriptableScratchMorph methodsFor: 'dialog ops'!
getUserResponse
	^ DialogBoxMorph getUserResponse! !

!ScriptableScratchMorph methodsFor: 'dialog ops'!
informInDialog: t1 
	DialogBoxMorph inform: t1! !

!ScriptableScratchMorph methodsFor: 'dialog ops'!
informInDialogWithCancel: t1 
	DialogBoxMorph informWithCancel: t1! !

!ScriptableScratchMorph methodsFor: 'dialog ops'!
warnInDialog: t1 
	DialogBoxMorph warn: t1! !

!ScriptableScratchMorph methodsFor: 'dictionary ops'!
addDict
	| t1 t2 t3 |
	(t1 _ self ownerThatIsA: ScratchFrameMorph) ifNil: [^ self beep].
	t2 _ NewVariableDialog ask: 'Dictionary name?'.
	t2 = #cancelled ifTrue: [^ self].
	t3 _ t2 first.
	t2 second
		ifTrue: [self createDictNamed: t3]
		ifFalse: [t1 workPane createDictNamed: t3].
	t1 viewerPane categoryChanged: 'variables'! !

!ScriptableScratchMorph methodsFor: 'dictionary ops'!
dialogAnswer
	^ dialogAns! !

!ScriptableScratchMorph methodsFor: 'math ops'!
falseBool
	^ false! !

!ScriptableScratchMorph methodsFor: 'math ops'!
power: t1 with: t2 
	^ t1 raisedTo: t2! !

!ScriptableScratchMorph methodsFor: 'math ops'!
quotientOf: t1 dividedBy: t2 
	^ t1 // t2! !

!ScriptableScratchMorph methodsFor: 'math ops'!
remainderOf: t1 dividedBy: t2 
	^ t1 \\ t2! !

!ScriptableScratchMorph methodsFor: 'math ops'!
reporterIf: t1 then: t2 else: t3 
	| t4 |
	t1
		ifTrue: [t4 _ t2]
		ifFalse: [t4 _ t3].
	^ t4! !

!ScriptableScratchMorph methodsFor: 'math ops'!
triple: t1 
	^ t1 * 3! !

!ScriptableScratchMorph methodsFor: 'math ops'!
trueBool
	^ true! !

!ScriptableScratchMorph methodsFor: 'mesh ops'!
getIp
	| t1 t2 t3 |
	Socket initializeNetwork.
	t1 _ NetNameResolver localHostAddress.
	t2 _ nil.
	t3 _ NetNameResolver stringFromAddress: t1.
	(t2 notNil and: [t2 ~= t1])
		ifTrue: [t3 _ t3 , String cr , 'Internet:   ' , (NetNameResolver stringFromAddress: t2)].
	^ t3! !

!ScriptableScratchMorph methodsFor: 'mesh ops'!
hostMesh
	| t1 t2 |
	(t1 _ self ownerThatIsA: ScratchFrameMorph) ifNil: [^ self].
	t1 workPane scratchServer
		ifNil: 
			[t2 _ ScratchServer new.
			t2 stage: t1 workPane.
			t1 workPane scratchServer: t2].
	t1 workPane scratchServer startHosting! !

!ScriptableScratchMorph methodsFor: 'mesh ops'!
joinMesh
	| t1 |
	t1 _ self ownerThatIsA: ScratchFrameMorph.
	t1 ifNotNil: [t1 joinScratchSession]! !

!ScriptableScratchMorph methodsFor: 'mesh ops'!
joinMeshAt: t1 
	| t2 t3 t4 |
	t4 _ self ownerThatIsA: ScratchFrameMorph.
	t2 _ ScratchServer new.
	t2 stage: t4 workPane.
	t4 workPane scratchServer: t2.
	t1 size = 0 ifTrue: [^ self].
	t3 _ t4 workPane scratchServer joinSessionAt: t1.
	t3 ifFalse: [DialogBoxMorph warn: 'Could not connect to ' , t1]! !

!ScriptableScratchMorph methodsFor: 'mesh ops'!
leaveMesh
	| t1 |
	t1 _ self ownerThatIsA: ScratchFrameMorph.
	t1 ifNotNil: [t1 exitScratchSession]! !

!ScriptableScratchMorph methodsFor: 'mesh ops'!
readme
	^ self! !

!ScriptableScratchMorph methodsFor: 'other ops'!
computeFunction: t1 of: t2 
	'abs' = t1 ifTrue: [^ t2 abs].
	'sqrt' = t1 ifTrue: [^ t2 sqrt].
	'sin' = t1 ifTrue: [^ t2 degreesToRadians sin].
	'cos' = t1 ifTrue: [^ t2 degreesToRadians cos].
	'tan' = t1 ifTrue: [^ t2 degreesToRadians tan].
	'asin' = t1 ifTrue: [^ (t2 within: -1.0 and: 1.0) arcSin radiansToDegrees].
	'acos' = t1 ifTrue: [^ (t2 within: -1.0 and: 1.0) arcCos radiansToDegrees].
	'atan' = t1 ifTrue: [^ t2 arcTan radiansToDegrees].
	'ln' = t1 ifTrue: [^ t2 ln].
	'log' = t1 ifTrue: [^ t2 log].
	'e ^' = t1 ifTrue: [^ t2 exp].
	'10 ^' = t1 ifTrue: [^ 10.0 raisedTo: t2].
	'pos' = t1 ifTrue: [^ t2 abs].
	'neg' = t1 ifTrue: [^ t2 abs negated].
	^ 0! !

!ScriptableScratchMorph methodsFor: 'other ops'!
doNothing
	self
		wait: 0
		elapsed: 0
		from: 0! !

!ScriptableScratchMorph methodsFor: 'other ops'!
doNothing: t1 
	^ self! !

!ScriptableScratchMorph methodsFor: 'other ops'!
mathFunctionNames
	^ #('abs' 'sqrt' 'sin' 'cos' 'tan' 'asin' 'acos' 'atan' 'ln' 'log' 'e ^' '10 ^' 'pos' 'neg' )! !

!ScriptableScratchMorph methodsFor: 'other ops'!
newDialog: t1 
	| t2 t3 t4 |
	(t2 _ self ownerThatIsA: ScratchFrameMorph) ifNil: [^ self beep].
	dialogAns _ StringDialog ask: t1 asString! !

!ScriptableScratchMorph methodsFor: 'sensing ops'!
joinMesh: t1 
	| t2 t3 t4 |
	(t4 _ self ownerThatIsA: ScratchFrameMorph) ifNil: [(t4 _ (self ownerThatIsA: OffscreenWorldMorph) frame) ifNil: [^ self]].
	t2 _ ScratchServer new.
	t2 stage: t4 workPane.
	t4 workPane scratchServer: t2.
	t1 size = 0 ifTrue: [^ ''].
	t3 _ t4 workPane scratchServer joinSessionAt: t1! !

!ScriptableScratchMorph methodsFor: 'sensing ops'!
reporterAsk: t1 
	| t2 t3 |
	(t2 _ self ownerThatIsA: ScratchStageMorph) ifNil: [^ self].
	t3 _ ScratchPrompterMorph new.
	(self isKindOf: ScratchStageMorph)
		| self isHidden
		ifTrue: [t3 question: t1]
		ifFalse: 
			[self showQuestion: t1.
			t3 sprite: self].
	t3 left: t2 center x - (t3 width // 2).
	t3 bottom: t2 bottom - 5.
	t3 isSticky: true.
	t2 addMorphFront: t3.
	t3 grabKeyboardFocus.
	^ ScratchPrompterMorph lastAnswer! !

!ScriptableScratchMorph methodsFor: 'sensing ops'!
soundNote
	^ self class soundRecorder note! !

!ScriptableScratchMorph methodsFor: 'squeak ops'!
doForMe: t1 
	^ Compiler
		evaluate: t1 asString
		for: self
		logged: false! !

!ScriptableScratchMorph methodsFor: 'squeak ops'!
readScratchSkin
	ScratchFrameMorph readSkinFrom: (FileDirectory default directoryNamed: 'ScratchSkin')! !

!ScriptableScratchMorph methodsFor: 'squeak ops'!
selfVariable: t1 
	^ self t1! !

!ScriptableScratchMorph methodsFor: 'squeak ops'!
transcriptCr
	Transcript cr! !

!ScriptableScratchMorph methodsFor: 'squeak ops'!
transcriptShow: t1 
	Transcript show: t1! !

!ScriptableScratchMorph methodsFor: 'string ops'!
capitalOf: t1 
	^ t1 asUppercase! !

!ScriptableScratchMorph methodsFor: 'string ops'!
lowercaseOf: t1 
	^ t1 asLowercase! !

!ScriptableScratchMorph methodsFor: 'variables'!
variableBlockColor
	^ Color
		h: 0
		s: 1
		v: 0! !

!ScriptableScratchMorph methodsFor: 'variables'!
variableEditMenu
	^ #('increment' 'decrement' )! !


!ScratchSpriteMorph methodsFor: 'motion ops'!
glideSecs: t1 toX: t2 y: t3 elapsed: t4 from: t5 
	| t6 t7 |
	t5 ifNil: [^ self referencePosition].
	t7 _ t2 @ t3.
	t1 < 0.001
		ifTrue: [t6 _ 1]
		ifFalse: [t6 _ t4 asFloat / (1000.0 * t1)].
	t6 > 1.0 ifTrue: [t6 _ 1].
	t6 < 0.0 ifTrue: [t6 _ 0].
	self referencePosition: t5 + (t6 * (t7 - t5)) truncated! !

!ScratchSpriteMorph methodsFor: 'sensing ops'!
text: t1 
	^ t1 asString! !


!ScriptableScratchMorph class methodsFor: 'class initialization'!
initialize
	Experimental _ false.
	ScratchOrigin _ 0 @ 0.
	RandomGen _ Random new.
	TimerStartMSecs _ Time millisecondClockValue.
	ListBlockColor _ Color
				h: 0
				s: 0.92
				v: 0.85! !

!ScriptableScratchMorph class methodsFor: 'block specs'!
blockColorFor: t1 
	'control' = t1 ifTrue: [^ Color
			h: 41
			s: 0.85
			v: 0.9].
	'motion' = t1 ifTrue: [^ Color
			h: 225
			s: 0.65
			v: 0.83].
	'motor' = t1 ifTrue: [^ Color
			h: 220
			s: 0.85
			v: 0.725].
	'looks' = t1 ifTrue: [^ Color
			h: 264
			s: 0.62
			v: 0.89].
	'pen' = t1 ifTrue: [^ Color
			h: 165
			s: 1
			v: 0.63].
	'operators' = t1 ifTrue: [^ Color
			h: 93
			s: 0.9
			v: 0.76].
	'sound' = t1 ifTrue: [^ Color
			h: 296
			s: 0.66
			v: 0.85].
	'sensing' = t1 ifTrue: [^ Color
			h: 200
			s: 0.98
			v: 0.86].
	'variables' = t1 ifTrue: [^ Color
			h: 25
			s: 0.88
			v: 0.95].
	'other' = t1 ifTrue: [^ Color
			h: 237
			s: 63
			v: 88].
	'squeak' = t1 ifTrue: [^ Color
			h: 25
			s: 0.88
			v: 0.95].
	'dialogs' = t1 ifTrue: [^ Color
			h: 93
			s: 0.9
			v: 0.76].
	'mesh' = t1 ifTrue: [^ Color
			h: 41
			s: 0.85
			v: 0.9].
	'list' = t1 ifTrue: [^ ListBlockColor].
	^ Color
		h: 0
		s: 0.81
		v: 0.83! !

!ScriptableScratchMorph class methodsFor: 'block specs'!
blockSpecs
	| t1 |
	t1 _ #('control' ('when %m clicked' #S #-) ('when %k key pressed' #K #-) ('when %m clicked' #M #-) #- ('wait %n secs' #t #wait:elapsed:from: 1) #- ('forever' #c #doForever) ('repeat %n' #c #doRepeat 10) #- ('broadcast %e' #- #broadcast:) ('broadcast %e and wait' #s #doBroadcastAndWait) ('when I receive %e' #E #-) #- ('forever if %b' #c #doForeverIf) ('if %b' #c #doIf) ('if %b' #c #doIfElse) ('wait until %b' #s #doWaitUntil) ('repeat until %b' #c #doUntil) #- ('stop script' #s #doReturn) ('stop all' #- #stopAll) 'operators' ('%n tripled' #r #triple:) #- ('%n + %n' #r #+ #- #-) ('%n - %n' #r #- #- #-) ('%n * %n' #r #* #- #-) ('%n / %n' #r #/ #- #-) #- ('%n ^ %n' #r #power:with: #- #-) ('quotient of %n / %n' #r #quotientOf:dividedBy: #- #-) ('remainder of %n / %n' #r #remainderOf:dividedBy: #- #-) #- ('pick random %n to %n' #r #randomFrom:to: 1 10) #- ('%s < %s' #b #< '' '') ('%s = %s' #b #= '' '') ('%s > %s' #b #> '' '') #- ('true' #b #trueBool) ('false' #b #falseBool) #- ('%b and %b' #b #&) ('%b or %b' #b #|) ('not %b' #b #not) #- ('join %s %s' #r #concatenate:with: 'hello ' 'world') ('letter %n of %s' #r #letter:of: 1 'world') ('length of %s' #r #stringLength: 'world') #- ('%s as uppercase' #r #capitalOf: 'world') ('%s as lowercase' #r #lowercaseOf: 'WORLD') #- ('ascii for %s' #r #asciiFor:) #- ('%n mod %n' #r #\\ #- #-) ('round %n' #r #rounded #-) #- ('%f of %n' #r #computeFunction:of: 'sqrt' 10) 'sound' ('play sound %S' #- #playSound:) ('play sound %S until done' #s #doPlaySoundAndWait) ('rewind sound %S' #- #rewindSound:) ('stop all sounds' #- #stopAllSounds) #- ('play drum %D for %n beats' #t #drum:duration:elapsed:from: 48 0.2) ('rest for %n beats' #t #rest:elapsed:from: 0.2) #- ('play note %N for %n beats' #t #noteOn:duration:elapsed:from: 60 0.5) ('set instrument to %I' #- #midiInstrument: 1) #- ('change volume by %n' #- #changeVolumeBy: -10) ('set volume to %n%' #- #setVolumeTo: 100) ('volume' #r #volume) #- ('change tempo by %n' #- #changeTempoBy: 20) ('set tempo to %n bpm' #- #setTempoTo: 60) ('tempo' #r #tempo) 'motor' ('motor on for %n secs' #t #motorOnFor:elapsed:from: 1) ('motor on' #- #allMotorsOn) ('motor off' #- #allMotorsOff) ('motor power %n' #- #startMotorPower: 100) ('motor direction %W' #- #setMotorDirection: 'this way') 'variables' ('show variable %v' #- #showVariable:) ('hide variable %v' #- #hideVariable:) 'list' ('add %s to %L' #- #append:toList: 'thing') #- ('delete %y of %L' #- #deleteLine:ofList: 1) ('insert %s at %i of %L' #- #insert:at:ofList: 'thing' 1) ('replace item %i of %L with %s' #- #setLine:ofList:to: 1 'list' 'thing') #- ('item %i of %L' #r #getLine:ofList: 1) ('length of %L' #r #lineCountOfList:) ('%L contains %s' #b #list:contains: 'list' 'thing') 'other' ('add variable with user input' #- #addGlobalVariable) ('get variable %s' #r #getVar:) ('delete variable %s' #- #deleteVariable:) ('delete self' #- #deleteSprite) #- ('// %s' #- #doNothing: 'Comment') #- ('dialog %s' #- #newDialog: 'Custom dialog..') ('dialog answer' #r #dialogAnswer) #- 'squeak' ('transcript message %s' #- #transcriptShow: 'Hello, world!!') ('transcript new line' #- #transcriptCr) #- ('self %s' #- #doForMe:) ('self %s' #r #selfVariable:) 'dialogs' ('%t %s in dialog' #- #askInDialog:) ('prompt %s in dialog initial answer? %b initial: %s with cancel? %b' #- #ask:withCancel:isInitial:initialAnswer:) #- ('dialog answer' #r #dialogAnswer) 'mesh' ('host Mesh' #- #hostMesh) ('join Mesh at %s' #- #joinMeshAt:) ('leave Mesh' #- #leaveMesh) ('IP address' #r #getIp) ).
	^ t1 , self obsoleteBlockSpecs! !


!ScratchSpriteMorph class methodsFor: 'block specs'!
blockSpecs
	| t1 |
	t1 _ #('motion' ('move %n steps' #- #forward:) ('turn %n degrees' #- #turnRight: 15) ('turn %n degrees' #- #turnLeft: 15) #- ('point in direction %d' #- #heading: 90) ('point towards x: %n y: %n' #- #pointToX:y: 0 0) ('point towards %m' #- #pointTowards:) #- ('go to x:%n y:%n' #- #gotoX:y: 0 0) ('go to %m' #- #gotoSpriteOrMouse:) ('glide %n secs to x:%n y:%n' #t #glideSecs:toX:y:elapsed:from: 1 50 50) #- ('change x by %n' #- #changeXposBy: 10) ('set x to %n' #- #xpos: 0) ('change y by %n' #- #changeYposBy: 10) ('set y to %n' #- #ypos: 0) #- ('if on edge, bounce' #- #bounceOffEdge) #- ('x position' #r #xpos) ('y position' #r #ypos) ('direction' #r #heading) 'pen' ('clear' #- #clearPenTrails) #- ('pen down' #- #putPenDown) ('pen up' #- #putPenUp) #- ('set pen color to %c' #- #penColor:) ('change pen color by %n' #- #changePenHueBy:) ('set pen color to %n' #- #setPenHueTo: 0) #- ('change pen shade by %n' #- #changePenShadeBy:) ('set pen shade to %n' #- #setPenShadeTo: 50) #- ('change pen size by %n' #- #changePenSizeBy: 1) ('set pen size to %n' #- #penSize: 1) #- ('stamp' #- #stampCostume) ).
	t1 _ t1 , #('looks' ('switch to costume %l' #- #lookLike:) ('next costume' #- #nextCostume) ('costume #' #r #costumeIndex) ('change costume by %n' #- #changeCostumeIndexBy: 1) #- ('edit current costume' #- #editDrawing) #- ('say %s for %n secs' #t #say:duration:elapsed:from: 'Hello!!' 2) ('say %s' #- #say: 'Hello!!') ('think %s for %n secs' #t #think:duration:elapsed:from: 'Hmm...' 2) ('think %s' #- #think: 'Hmm...') ('say nothing' #- #sayNothing) #- ('change %g effect by %n' #- #changeGraphicEffect:by: 'color' 25) ('set %g effect to %n' #- #setGraphicEffect:to: 'color' 0) ('clear graphic effects' #- #filterReset) #- ('change size by %n' #- #changeSizeBy:) ('set size to %n%' #- #setSizeTo: 100) ('change stretch by %n' #- #changeStretchBy:) ('set stretch to %n%' #- #setStretchTo: 100) ('size' #r #scale) #- ('show' #- #show) ('hide' #- #hide) #- ('go to front' #- #comeToFront) ('go back %n layers' #- #goBackByLayers: 1) #- 'sensing' ('touching %m?' #b #touching:) ('touching color %C?' #b #touchingColor:) ('color %C is touching %C?' #b #color:sees:) #- ('ask %s and wait' #s #doAsk 'What''s your name?') ('answer' #r #answer) ('is asking something?' #b #promptInProgress) #- ('mouse x' #r #mouseX) ('mouse y' #r #mouseY) ('mouse down?' #b #mousePressed) #- ('key %k pressed?' #b #keyPressed: 'space') #- ('distance to %m' #r #distanceTo:) #- ('reset timer' #- #timerReset) ('timer' #r #timer) #- ('%a of %m' #r #getAttribute:of:) #- ('loudness' #r #soundLevel) ('loud?' #b #isLoud) #~ ('%H sensor value' #r #sensor: 'slider') ('sensor %h?' #b #sensorPressed: 'button pressed') ('%s attribute' #r #getAttribute:) #~ ('%s' #r #text: #text) ).
	^ t1 , super blockSpecs! !


!ScratchStageMorph class methodsFor: 'block specs'!
blockSpecs
	| t1 |
	t1 _ #('sensing' ('ask %s and wait' #s #doAsk 'What''s your name?') ('answer' #r #answer) #- ('mouse x' #r #mouseX) ('mouse y' #r #mouseY) ('mouse down?' #b #mousePressed) #- ('key %k pressed?' #b #keyPressed: 'space') #- ('reset timer' #- #timerReset) ('timer' #r #timer) #- ('%a of %m' #r #getAttribute:of:) #- ('loudness' #r #soundLevel) ('loud?' #b #isLoud) #~ ('%H sensor value' #r #sensor: 'slider') ('sensor %h?' #b #sensorPressed: 'button pressed') 'looks' ('switch to background %l' #- #showBackground: 'background1') ('next background' #- #nextBackground) ('change bacround by %n' #- #changeBackgroundIndexBy: 1) ('edit current background' #- #editDrawing) ('background #' #r #backgroundIndex) #- ('change %g effect by %n' #- #changeGraphicEffect:by: 'color' 25) ('set %g effect to %n' #- #setGraphicEffect:to: 'color' 0) ('clear graphic effects' #- #filterReset) #- 'pen' ('clear' #- #clearPenTrails) ).
	^ t1 , super blockSpecs! !

ScratchSpriteMorph class removeSelector: #bslockSpecs!
ScratchSpriteMorph class removeSelector: #!
ScriptableScratchMorph initialize!
ScratchSpriteMorph removeSelector: #GlideRight!
ScratchSpriteMorph removeSelector: #GlideRightIn:Right:!
ScratchSpriteMorph removeSelector: #double:!
ScratchSpriteMorph removeSelector: #glideRight:toX:y:elapsed:from:!
ScratchSpriteMorph removeSelector: #glideRightInSecs:distance:elapsed:from:!
ScriptableScratchMorph removeSelector: #double:!
ScriptableScratchMorph removeSelector: #if:then:else:!
ScriptableScratchMorph removeSelector: #pressGreenFlagButton!
ScriptableScratchMorph removeSelector: #replace:of:with:!
ScriptableScratchMorph removeSelector: #reporterAsk:promptForInput:!
ScriptableScratchMorph removeSelector: #shoutGo!

!ScriptableScratchMorph reorganize!
('accessing' costume costumeChangeMSecs costumeForm filteredForm form form: imageForm inPresentationMode isClone isClone: isColorable isScriptable isSprite isVisible media objName objName: renewFilterPack rotatedForm rotationCenter:)
('blocks' addEventNamesTo: addGenericListBlocksTo:y: addGenericVariableBlocksTo:x:y: addListReportersTo:x:y: addVariableReportersTo:x:y: blockCategories blockFromSpec:color: blockFromTuple:receiver: blockReceiver blockSpecForSelector: blockWithID: blocksBin blocksFor: convertStacksToTuples convertTuplesToStacks costumesPage: createBlock:atPosition:onPage: createToggleButtonFor: defaultArgsFor: hatBlockFromTuple:receiver: hatBlockType: scriptsAsTuples: soundsPage: stackFromTupleList:receiver: variableBlockFromTuple:receiver: variablesPage viewBlocksAndScripts viewerPageForCategory: viewerPageForMotion viewerPageForSensing)
('dialog ops' ask:withCancel:initialAnswer: ask:withCancel:isInitial:initialAnswer: askInDialog: askInDialogWithCancel: dialogTypeDropdown do:what:withCancel: getUserResponse informInDialog: informInDialogWithCancel: warnInDialog:)
('dictionary ops' addDict dialogAnswer)
('dropping/grabbing' justDroppedInto:event: rejectDropEvent:)
('event handling' click: doubleClick: handleTool:hand: handlesMouseDown: mouseDown: mouseHold: startDrag:)
('initialization' initialize)
('list ops' addGlobalList addList append:toList: asListElement: contentsOfList: createListNamed: defaultListName deleteLine:ofList: deleteList deleteList: getLine:ofList: insert:at:ofList: lineCountOfList: lineNum:forList: list:contains: listIndexForDeleteMenu listIndexMenu listNamed:ifNone: listVarMenu listVarNames lists setLine:ofList:to:)
('looks ops' changeCostumeIndexBy: changeGraphicEffect:by: changeVisibilityBy: costumeFromName: costumeIndex costumeIndex: costumeNameFromNumber: filterReset graphicEffectNames lookLike: nextCostume penDown sayNothing sceneNames setGraphicEffect:to: setVisibilityTo: transparency transparency: visibility visibility:)
('math ops' falseBool power:with: quotientOf:dividedBy: remainderOf:dividedBy: reporterIf:then:else: triple: trueBool)
('media' addMediaItem: costumeNames defaultImageMedia deleteMedia: drawNewCostume duplicateMedia: editedForm:textBox: importImage importMedia: importSound insertMedia:before: mediaNameFromFileName:default: onlyCostume: recordSound revertToCostume: savePhoto: saveSound:name: setMedia: soleCostume: soundNames takePhoto unusedMediaNameFromBaseName: unusedMediaNameFromBaseName:forMedia:)
('mesh ops' getIp hostMesh joinMesh joinMeshAt: leaveMesh readme)
('motor ops' allMotorsOff allMotorsOn motor:direction: motor:power: motorDirection motorNames motorOff: motorOn: motorOn:duration:elapsed:from: motorOnFor:elapsed:from: setMotorDirection: startMotorPower:)
('object i/o' initFieldsFrom:version: storeFieldsOn:)
('other ops' broadcast: broadcast:withArgument: computeFunction:of: doNothing doNothing: eventReceived: mathFunctionNames mwait:elapsed:from: newDialog: randomFrom:to: stopAll stopAllSounds wait:elapsed:from:)
('private' clearMediaAndCostume copyForExport copyListsFor: copyRecordingIn: costumeChanged deleteSprite interpretStringAsNumberIfPossible: nextInstanceName printSummaryOn: projectDirectory serialized spriteNameInUse: stopPlaying undoableDeleteSprite updateMediaCategory vars:blocksBin: vars:lists:blocksBin: zoomRectFrom:to:)
('right button menu' duplicateNoAttach editDrawing editDrawingOldCostumeName:deleteOnCancel: exportObject makeVisible rightButtonMenu)
('scripts' addComment: addStack: duplicate scripts)
('sensing ops' answer asciiFor: attributeNames coerceSpriteArg: getAttribute: getAttribute:of: hookupBooleanSensorNames hookupSensorNames hookupSensorNumber indexForSensorName: isLoud joinMesh: keyNames keyPressed: mousePressed mouseX mouseY promptForInput: promptInProgress reporterAsk: sensor: sensorPressed: soundLevel soundNote timer timerReset)
('sound ops' changeTempoBy: changeVolumeBy: drum:duration:elapsed:from: midiDrumMenu midiInstrument: midiInstrumentMenu midiNoteMenu noteOn:duration:elapsed:from: noteSelector numberInParens: playMidi: playSound: rest:elapsed:from: rewindSound: setInstrument: setInstrumentMenu setTempoTo: setVolumeTo: soundFromIndex: soundNamed:ifAbsent: tempo volume)
('squeak ops' doForMe: readScratchSkin selfVariable: transcriptCr transcriptShow:)
('stepping' step stepTime)
('string ops' capitalOf: concatenate:with: letter:of: letterNum:of: lowercaseOf: stringLength:)
('variables' addGlobalVariable addVariable addVariable: addVariable:value: addWatcherForNewVariable:withScope: allVarNames changeVar:by: deleteVariable deleteVariable: ensureListExists: ensureVariableExists: getVar: hideVariable: setVar:to: showOrHideVariable:show: showVariable: varNames varNamesMenu variableBlockColor variableEditMenu variableNameInUse:)
!

CommandBlockMorph removeSelector: #changeSpec!
Morph subclass: #BlockMorph
	instanceVariableNames: 'isSpecialForm oldColor highlightColor1 highlightColor2 shadowColor scratchProc hadError blockLayoutNeeded cachedForm cachedFeedbackForm copyTooltip lastLayoutTime isFlat '
	classVariableNames: 'AlternateDrawing ArgFont CBlockBracketThickness DebugMenu LabelColor LabelFont PuzzleInset PuzzleWidth '
	poolDictionaries: ''
	category: 'Scratch-Blocks'!
